part of flutter_core_image_filters;

class CIColorCubeWithIntensityConfiguration extends CIFilterConfiguration
    with CubeDimensionMixin, CubeDataMixin {
  final BoolParameter _extrapolate;
  final NumberParameter _intensity;

  CIColorCubeWithIntensityConfiguration()
      : _extrapolate =
            NSBoolParameter('inputExtrapolate', 'Extrapolate', false),
        _intensity = SliderNSNumberParameter(
          'inputIntensity',
          'Intensity',
          1.0,
          min: 0.0,
          max: 1.0,
        ),
        super('CIColorCubeWithIntensityFilter');

  set extrapolate(bool value) {
    _extrapolate.value = value;
  }

  set intensity(double value) {
    _intensity.value = value;
  }

  @override
  Iterable<CICategory> get categories => {
        CICategory.colorEffect,
        CICategory.video,
        CICategory.interlaced,
        CICategory.nonSquarePixels,
        CICategory.stillImage,
        CICategory.highDynamicRange,
        CICategory.builtIn,
      };

  @override
  List<ConfigurationParameter> get parameters =>
      [...super.parameters, _intensity];
}
